import { Octokit } from '@technote-space/github-action-helper/dist/types';
import { Logger, GitHelper, ApiHelper } from '@technote-space/github-action-helper';
import { PullsListResponseData } from '@octokit/types';
import { ActionContext, CommandOutput, Null } from '../types';
export declare const getApiHelper: (octokit: Octokit, context: ActionContext, logger?: Logger | undefined) => ApiHelper;
export declare const clone: (helper: GitHelper, logger: Logger, octokit: Octokit, context: ActionContext) => Promise<void>;
export declare const checkBranch: (helper: GitHelper, logger: Logger, octokit: Octokit, context: ActionContext) => Promise<boolean>;
export declare const getDiff: (helper: GitHelper, logger: Logger) => Promise<string[]>;
export declare const getRefDiff: (compare: string, helper: GitHelper, logger: Logger, context: ActionContext) => Promise<string[]>;
export declare const config: (helper: GitHelper, logger: Logger, context: ActionContext) => Promise<void>;
export declare const merge: (branch: string, helper: GitHelper, logger: Logger, context: ActionContext) => Promise<boolean>;
export declare const abortMerge: (helper: GitHelper, logger: Logger) => Promise<void>;
export declare const commit: (helper: GitHelper, logger: Logger, context: ActionContext) => Promise<void>;
export declare const push: (branchName: string, helper: GitHelper, logger: Logger, context: ActionContext) => Promise<void>;
export declare const isMergeable: (number: number, octokit: Octokit, context: ActionContext) => Promise<boolean>;
export declare const afterCreatePr: (branchName: string, number: number, helper: GitHelper, logger: Logger, octokit: Octokit, context: ActionContext) => Promise<void>;
export declare const updatePr: (branchName: string, files: string[], output: CommandOutput[], helper: GitHelper, logger: Logger, octokit: Octokit, context: ActionContext) => Promise<boolean>;
export declare const getChangedFiles: (helper: GitHelper, logger: Logger, octokit: Octokit, context: ActionContext) => Promise<{
    files: string[];
    output: CommandOutput[];
}>;
export declare const getChangedFilesForRebase: (helper: GitHelper, logger: Logger, octokit: Octokit, context: ActionContext) => Promise<{
    files: string[];
    output: CommandOutput[];
}>;
export declare const closePR: (branchName: string, logger: Logger, context: ActionContext, message?: string | undefined) => Promise<void>;
export declare const resolveConflicts: (branchName: string, helper: GitHelper, logger: Logger, octokit: Octokit, context: ActionContext) => Promise<void>;
export declare const getDefaultBranch: (octokit: Octokit, context: ActionContext) => Promise<string>;
export declare const getCurrentVersion: (octokit: Octokit, context: ActionContext) => Promise<string>;
export declare const getNewPatchVersion: (octokit: Octokit, context: ActionContext) => Promise<string>;
export declare const getNewMinorVersion: (octokit: Octokit, context: ActionContext) => Promise<string>;
export declare const getNewMajorVersion: (octokit: Octokit, context: ActionContext) => Promise<string>;
export declare const findPR: (branchName: string, octokit: Octokit, context: ActionContext) => Promise<PullsListResponseData[number] | Null>;
